Remove redundant "if use iodbc" check (and merge it with the "odbc" use_with).
[mjo-overlay.git] / dev-lang / php / php-5.6.9.ebuild
1 # Copyright 1999-2015 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/dev-lang/php/php-5.6.9.ebuild,v 1.5 2015/05/28 05:09:40 jer Exp $
4
5 EAPI=5
6
7 inherit eutils autotools flag-o-matic versionator depend.apache apache-module db-use libtool systemd
8
9 KEYWORDS="~alpha amd64 ~arm hppa ~ia64 ~mips ~ppc ppc64 ~s390 ~sh ~sparc x86 ~amd64-fbsd ~x86-fbsd ~x86-freebsd ~amd64-linux ~ia64-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos"
10
11 function php_get_uri ()
12 {
13 case "${1}" in
14 "php-pre")
15 echo "http://downloads.php.net/dsp/${2}"
16 ;;
17 "php")
18 echo "http://www.php.net/distributions/${2}"
19 ;;
20 "olemarkus")
21 echo "http://dev.gentoo.org/~olemarkus/php/${2}"
22 ;;
23 "gentoo")
24 echo "mirror://gentoo/${2}"
25 ;;
26 *)
27 die "unhandled case in php_get_uri"
28 ;;
29 esac
30 }
31
32 PHP_MV="$(get_major_version)"
33 SLOT="$(get_version_component_range 1-2)"
34
35 # alias, so we can handle different types of releases (finals, rcs, alphas,
36 # betas, ...) w/o changing the whole ebuild
37 PHP_PV="${PV/_rc/RC}"
38 PHP_PV="${PHP_PV/_alpha/alpha}"
39 PHP_PV="${PHP_PV/_beta/beta}"
40 PHP_RELEASE="php"
41 [[ ${PV} == ${PV/_alpha/} ]] || PHP_RELEASE="php-pre"
42 [[ ${PV} == ${PV/_beta/} ]] || PHP_RELEASE="php-pre"
43 [[ ${PV} == ${PV/_rc/} ]] || PHP_RELEASE="php-pre"
44 PHP_P="${PN}-${PHP_PV}"
45
46 PHP_SRC_URI="$(php_get_uri "${PHP_RELEASE}" "${PHP_P}.tar.bz2")"
47
48 PHP_FPM_CONF_VER="1"
49
50 SRC_URI="${PHP_SRC_URI}"
51
52 DESCRIPTION="The PHP language runtime engine: CLI, CGI, FPM/FastCGI, Apache2 and embed SAPIs"
53 HOMEPAGE="http://php.net/"
54 LICENSE="PHP-3"
55
56 S="${WORKDIR}/${PHP_P}"
57
58 # We can build the following SAPIs in the given order
59 SAPIS="embed cli cgi fpm apache2"
60
61 # SAPIs and SAPI-specific USE flags (cli SAPI is default on):
62 IUSE="${IUSE}
63 ${SAPIS/cli/+cli}
64 threads"
65
66 IUSE="${IUSE} bcmath berkdb bzip2 calendar cdb cjk
67 crypt +ctype curl debug
68 enchant exif frontbase +fileinfo +filter firebird
69 flatfile ftp gd gdbm gmp +hash +iconv imap inifile
70 intl iodbc ipv6 +json kerberos ldap ldap-sasl libedit mhash
71 mssql mysql libmysqlclient mysqli nls
72 oci8-instant-client odbc +opcache pcntl pdo +phar +posix postgres qdbm
73 readline recode selinux +session sharedmem
74 +simplexml snmp soap sockets spell sqlite ssl
75 sybase-ct sysvipc systemd tidy +tokenizer truetype unicode vpx wddx
76 +xml xmlreader xmlwriter xmlrpc xpm xslt zip zlib"
77
78 DEPEND="
79 >=app-eselect/eselect-php-0.7.1-r3[apache2?,fpm?]
80 >=dev-libs/libpcre-8.32[unicode]
81 apache2? ( || ( >=www-servers/apache-2.4[apache2_modules_unixd,threads=]
82 <www-servers/apache-2.4[threads=] ) )
83 berkdb? ( =sys-libs/db-4* )
84 bzip2? ( app-arch/bzip2 )
85 cdb? ( || ( dev-db/cdb dev-db/tinycdb ) )
86 cjk? ( !gd? (
87 virtual/jpeg:0
88 media-libs/libpng:0=
89 sys-libs/zlib
90 ) )
91 crypt? ( >=dev-libs/libmcrypt-2.4 )
92 curl? ( >=net-misc/curl-7.10.5 )
93 enchant? ( app-text/enchant )
94 exif? ( !gd? (
95 virtual/jpeg:0
96 media-libs/libpng:0=
97 sys-libs/zlib
98 ) )
99 firebird? ( dev-db/firebird )
100 gd? ( virtual/jpeg:0 media-libs/libpng:0= sys-libs/zlib )
101 gdbm? ( >=sys-libs/gdbm-1.8.0 )
102 gmp? ( >=dev-libs/gmp-4.1.2 )
103 iconv? ( virtual/libiconv )
104 imap? ( virtual/imap-c-client[ssl=] )
105 intl? ( dev-libs/icu:= )
106 iodbc? ( dev-db/libiodbc )
107 kerberos? ( virtual/krb5 )
108 ldap? ( >=net-nds/openldap-1.2.11 )
109 ldap-sasl? ( dev-libs/cyrus-sasl >=net-nds/openldap-1.2.11 )
110 libedit? ( || ( sys-freebsd/freebsd-lib dev-libs/libedit ) )
111 mssql? ( dev-db/freetds[mssql] )
112 libmysqlclient? (
113 mysql? ( virtual/mysql )
114 mysqli? ( >=virtual/mysql-4.1 )
115 )
116 nls? ( sys-devel/gettext )
117 oci8-instant-client? ( dev-db/oracle-instantclient-basic )
118 odbc? ( >=dev-db/unixODBC-1.8.13 )
119 postgres? ( dev-db/postgresql )
120 qdbm? ( dev-db/qdbm )
121 readline? ( sys-libs/readline )
122 recode? ( app-text/recode )
123 sharedmem? ( dev-libs/mm )
124 simplexml? ( >=dev-libs/libxml2-2.6.8 )
125 snmp? ( >=net-analyzer/net-snmp-5.2 )
126 soap? ( >=dev-libs/libxml2-2.6.8 )
127 spell? ( >=app-text/aspell-0.50 )
128 sqlite? ( >=dev-db/sqlite-3.7.6.3 )
129 ssl? ( >=dev-libs/openssl-0.9.7 )
130 sybase-ct? ( dev-db/freetds )
131 tidy? ( app-text/htmltidy )
132 truetype? (
133 =media-libs/freetype-2*
134 >=media-libs/t1lib-5.0.0
135 !gd? (
136 virtual/jpeg:0 media-libs/libpng:0= sys-libs/zlib )
137 )
138 unicode? ( dev-libs/oniguruma )
139 vpx? ( media-libs/libvpx )
140 wddx? ( >=dev-libs/libxml2-2.6.8 )
141 xml? ( >=dev-libs/libxml2-2.6.8 )
142 xmlrpc? ( >=dev-libs/libxml2-2.6.8 virtual/libiconv )
143 xmlreader? ( >=dev-libs/libxml2-2.6.8 )
144 xmlwriter? ( >=dev-libs/libxml2-2.6.8 )
145 xpm? (
146 x11-libs/libXpm
147 virtual/jpeg:0
148 media-libs/libpng:0= sys-libs/zlib
149 )
150 xslt? ( dev-libs/libxslt >=dev-libs/libxml2-2.6.8 )
151 zip? ( sys-libs/zlib )
152 zlib? ( sys-libs/zlib )
153 virtual/mta
154 "
155
156 php="=${CATEGORY}/${PF}"
157
158 REQUIRED_USE="
159 truetype? ( gd )
160 vpx? ( gd )
161 cjk? ( gd )
162 exif? ( gd )
163
164 xpm? ( gd )
165 gd? ( zlib )
166 simplexml? ( xml )
167 soap? ( xml )
168 wddx? ( xml )
169 xmlrpc? ( || ( xml iconv ) )
170 xmlreader? ( xml )
171 xslt? ( xml )
172 ldap-sasl? ( ldap )
173 mhash? ( hash )
174 phar? ( hash )
175 libmysqlclient? ( || (
176 mysql
177 mysqli
178 pdo
179 ) )
180
181 qdbm? ( !gdbm )
182 readline? ( !libedit )
183 recode? ( !imap !mysql !mysqli )
184 sharedmem? ( !threads )
185
186 !cli? ( !cgi? ( !fpm? ( !apache2? ( !embed? ( cli ) ) ) ) )"
187
188 RDEPEND="${DEPEND}"
189
190 RDEPEND="${RDEPEND}
191 fpm? (
192 selinux? ( sec-policy/selinux-phpfpm )
193 systemd? ( sys-apps/systemd ) )"
194
195 DEPEND="${DEPEND}
196 sys-devel/flex
197 >=sys-devel/m4-1.4.3
198 >=sys-devel/libtool-1.5.18"
199
200 # Allow users to install production version if they want to
201
202 case "${PHP_INI_VERSION}" in
203 production|development)
204 ;;
205 *)
206 PHP_INI_VERSION="development"
207 ;;
208 esac
209
210 PHP_INI_UPSTREAM="php.ini-${PHP_INI_VERSION}"
211 PHP_INI_FILE="php.ini"
212
213 want_apache
214
215 pkg_setup() {
216 depend.apache_pkg_setup
217 }
218
219 php_install_ini() {
220 local phpsapi="${1}"
221
222 # work out where we are installing the ini file
223 php_set_ini_dir "${phpsapi}"
224
225 local phpinisrc="${PHP_INI_UPSTREAM}-${phpsapi}"
226 cp "${PHP_INI_UPSTREAM}" "${phpinisrc}"
227
228 # default to /tmp for save_path, bug #282768
229 sed -e 's|^;session.save_path .*$|session.save_path = "'"${EPREFIX}"'/tmp"|g' -i "${phpinisrc}"
230
231 # Set the extension dir
232 sed -e "s|^extension_dir .*$|extension_dir = ${extension_dir}|g" -i "${phpinisrc}"
233
234 # Set the include path to point to where we want to find PEAR packages
235 sed -e 's|^;include_path = ".:/php/includes".*|include_path = ".:'"${EPREFIX}"'/usr/share/php'${PHP_MV}':'"${EPREFIX}"'/usr/share/php"|' -i "${phpinisrc}"
236
237 dodir "${PHP_INI_DIR#${EPREFIX}}"
238 insinto "${PHP_INI_DIR#${EPREFIX}}"
239 newins "${phpinisrc}" "${PHP_INI_FILE}"
240
241 elog "Installing php.ini for ${phpsapi} into ${PHP_INI_DIR#${EPREFIX}}"
242 elog
243
244 dodir "${PHP_EXT_INI_DIR#${EPREFIX}}"
245 dodir "${PHP_EXT_INI_DIR_ACTIVE#${EPREFIX}}"
246
247 if use_if_iuse opcache; then
248 elog "Adding opcache to $PHP_EXT_INI_DIR"
249 echo "zend_extension=${PHP_DESTDIR}/$(get_libdir)/opcache.so" >> "${D}/${PHP_EXT_INI_DIR}"/opcache.ini
250 dosym "${PHP_EXT_INI_DIR#${EPREFIX}}/opcache.ini" "${PHP_EXT_INI_DIR_ACTIVE#${EPREFIX}}/opcache.ini"
251 fi
252
253 # SAPI-specific handling
254
255 if [[ "${sapi}" == "fpm" ]] ; then
256 [[ -z ${PHP_FPM_CONF_VER} ]] && PHP_FPM_CONF_VER=0
257 einfo "Installing FPM CGI config file php-fpm.conf"
258 insinto "${PHP_INI_DIR#${EPREFIX}}"
259 newins "${FILESDIR}/php-fpm-r${PHP_FPM_CONF_VER}.conf" php-fpm.conf
260
261 # Remove bogus /etc/php-fpm.conf.default (bug 359906)
262 [[ -f "${ED}/etc/php-fpm.conf.default" ]] && rm "${ED}/etc/php-fpm.conf.default"
263 fi
264
265 # Install PHP ini files into /usr/share/php
266
267 dodoc php.ini-development
268 dodoc php.ini-production
269
270 }
271
272 php_set_ini_dir() {
273 PHP_INI_DIR="${EPREFIX}/etc/php/${1}-php${SLOT}"
274 PHP_EXT_INI_DIR="${PHP_INI_DIR}/ext"
275 PHP_EXT_INI_DIR_ACTIVE="${PHP_INI_DIR}/ext-active"
276 }
277
278 src_prepare() {
279 # USE=sharedmem (session/mod_mm to be exact) tries to mmap() this path
280 # ([empty session.save_path]/session_mm_[sapi][gid].sem)
281 # there is no easy way to circumvent that, all php calls during
282 # install use -n, so no php.ini file will be used.
283 # As such, this is the easiest way to get around
284 addpredict /session_mm_cli250.sem
285 addpredict /session_mm_cli0.sem
286
287 # Change PHP branding
288 # Get the alpha/beta/rc version
289 sed -re "s|^(PHP_EXTRA_VERSION=\").*(\")|\1-pl${PR/r/}-gentoo\2|g" \
290 -i configure.in || die "Unable to change PHP branding"
291
292 # Patch PHP to show Gentoo as the server platform
293 sed -e 's/PHP_UNAME=`uname -a | xargs`/PHP_UNAME=`uname -s -n -r -v | xargs`/g' \
294 -i configure.in || die "Failed to fix server platform name"
295
296 # Prevent PHP from activating the Apache config,
297 # as we will do that ourselves
298 sed -i \
299 -e "s,-i -a -n php${PHP_MV},-i -n php${PHP_MV},g" \
300 -e "s,-i -A -n php${PHP_MV},-i -n php${PHP_MV},g" \
301 configure sapi/apache2filter/config.m4 sapi/apache2handler/config.m4
302
303 # Patch PHP to support heimdal instead of mit-krb5
304 if has_version "app-crypt/heimdal" ; then
305 sed -e 's|gssapi_krb5|gssapi|g' -i acinclude.m4 \
306 || die "Failed to fix heimdal libname"
307 sed -e 's|PHP_ADD_LIBRARY(k5crypto, 1, $1)||g' -i acinclude.m4 \
308 || die "Failed to fix heimdal crypt library reference"
309 fi
310
311 # Fix build with libvpx-1.4.0, bug #545952 .
312 epatch "${FILESDIR}/${PN}-libvpx.patch"
313
314 #Add user patches #357637
315 epatch_user
316
317 #force rebuilding aclocal.m4
318 rm aclocal.m4
319 eautoreconf
320
321 if [[ ${CHOST} == *-darwin* ]] ; then
322 # http://bugs.php.net/bug.php?id=48795, bug #343481
323 sed -i -e '/BUILD_CGI="\\$(CC)/s/CC/CXX/' configure || die
324 fi
325 }
326
327 src_configure() {
328 addpredict /usr/share/snmp/mibs/.index
329 addpredict /var/lib/net-snmp/mib_indexes
330
331 PHP_DESTDIR="${EPREFIX}/usr/$(get_libdir)/php${SLOT}"
332
333 # This is a global variable and should be in caps. It isn't because the
334 # phpconfutils eclass relies on exactly this name...
335 # for --with-libdir see bug #327025
336 my_conf="
337 --prefix="${PHP_DESTDIR}"
338 --mandir="${PHP_DESTDIR}"/man
339 --infodir="${PHP_DESTDIR}"/info
340 --libdir="${PHP_DESTDIR}"/lib
341 --with-libdir=$(get_libdir)
342 --without-pear
343 $(use_enable threads maintainer-zts)"
344
345 # extension USE flag shared
346 my_conf+="
347 $(use_enable bcmath bcmath )
348 $(use_with bzip2 bz2 "${EPREFIX}"/usr)
349 $(use_enable calendar calendar )
350 $(use_enable ctype ctype )
351 $(use_with curl curl "${EPREFIX}"/usr)
352 $(use_enable xml dom )
353 $(use_with enchant enchant "${EPREFIX}"/usr)
354 $(use_enable exif exif )
355 $(use_enable fileinfo fileinfo )
356 $(use_enable filter filter )
357 $(use_enable ftp ftp )
358 $(use_with nls gettext "${EPREFIX}"/usr)
359 $(use_with gmp gmp "${EPREFIX}"/usr)
360 $(use_enable hash hash )
361 $(use_with mhash mhash "${EPREFIX}"/usr)
362 $(use_with iconv iconv $(use elibc_glibc || use elibc_musl || echo "${EPREFIX}"/usr))
363 $(use_enable intl intl )
364 $(use_enable ipv6 ipv6 )
365 $(use_enable json json )
366 $(use_with kerberos kerberos "${EPREFIX}"/usr)
367 $(use_enable xml libxml )
368 $(use_with xml libxml-dir "${EPREFIX}"/usr)
369 $(use_enable unicode mbstring )
370 $(use_with crypt mcrypt "${EPREFIX}"/usr)
371 $(use_with mssql mssql "${EPREFIX}"/usr)
372 $(use_with unicode onig "${EPREFIX}"/usr)
373 $(use_with ssl openssl "${EPREFIX}"/usr)
374 $(use_with ssl openssl-dir "${EPREFIX}"/usr)
375 $(use_enable pcntl pcntl )
376 $(use_enable phar phar )
377 $(use_enable pdo pdo )
378 $(use_enable opcache opcache )
379 $(use_with postgres pgsql "${EPREFIX}"/usr)
380 $(use_enable posix posix )
381 $(use_with spell pspell "${EPREFIX}"/usr)
382 $(use_with recode recode "${EPREFIX}"/usr)
383 $(use_enable simplexml simplexml )
384 $(use_enable sharedmem shmop )
385 $(use_with snmp snmp "${EPREFIX}"/usr)
386 $(use_enable soap soap )
387 $(use_enable sockets sockets )
388 $(use_with sqlite sqlite3 "${EPREFIX}"/usr)
389 $(use_with sybase-ct sybase-ct "${EPREFIX}"/usr)
390 $(use_enable sysvipc sysvmsg )
391 $(use_enable sysvipc sysvsem )
392 $(use_enable sysvipc sysvshm )
393 $(use_with systemd fpm-systemd)
394 $(use_with tidy tidy "${EPREFIX}"/usr)
395 $(use_enable tokenizer tokenizer )
396 $(use_enable wddx wddx )
397 $(use_enable xml xml )
398 $(use_enable xmlreader xmlreader )
399 $(use_enable xmlwriter xmlwriter )
400 $(use_with xmlrpc xmlrpc)
401 $(use_with xslt xsl "${EPREFIX}"/usr)
402 $(use_enable zip zip )
403 $(use_with zlib zlib "${EPREFIX}"/usr)
404 $(use_enable debug debug )"
405
406 # DBA support
407 if use cdb || use berkdb || use flatfile || use gdbm || use inifile \
408 || use qdbm ; then
409 my_conf="${my_conf} --enable-dba${shared}"
410 fi
411
412 # DBA drivers support
413 my_conf+="
414 $(use_with cdb cdb)
415 $(use_with berkdb db4 ${EPREFIX}/usr)
416 $(use_enable flatfile flatfile )
417 $(use_with gdbm gdbm ${EPREFIX}/usr)
418 $(use_enable inifile inifile )
419 $(use_with qdbm qdbm ${EPREFIX}/usr)"
420
421 # Support for the GD graphics library
422 my_conf+="
423 $(use_with truetype freetype-dir ${EPREFIX}/usr)
424 $(use_with truetype t1lib ${EPREFIX}/usr)
425 $(use_enable cjk gd-jis-conv )
426 $(use_with gd jpeg-dir ${EPREFIX}/usr)
427 $(use_with gd png-dir ${EPREFIX}/usr)
428 $(use_with xpm xpm-dir ${EPREFIX}/usr)
429 $(use_with vpx vpx-dir ${EPREFIX}/usr)"
430 # enable gd last, so configure can pick up the previous settings
431 my_conf+="
432 $(use_with gd gd)"
433
434 # IMAP support
435 if use imap ; then
436 my_conf+="
437 $(use_with imap imap ${EPREFIX}/usr)
438 $(use_with ssl imap-ssl ${EPREFIX}/usr)"
439 fi
440
441 # Interbase/firebird support
442 my_conf+="
443 $(use_with firebird interbase ${EPREFIX}/usr)"
444
445 # LDAP support
446 if use ldap ; then
447 my_conf+="
448 $(use_with ldap ldap ${EPREFIX}/usr)
449 $(use_with ldap-sasl ldap-sasl ${EPREFIX}/usr)"
450 fi
451
452 # MySQL support
453 local mysqllib="mysqlnd"
454 local mysqlilib="mysqlnd"
455 use libmysqlclient && mysqllib="${EPREFIX}/usr"
456 use libmysqlclient && mysqlilib="${EPREFIX}/usr/bin/mysql_config"
457
458 my_conf+=" $(use_with mysql mysql $mysqllib)"
459 my_conf+=" $(use_with mysqli mysqli $mysqlilib)"
460
461 local mysqlsock=" $(use_with mysql mysql-sock ${EPREFIX}/var/run/mysqld/mysqld.sock)"
462 if use mysql ; then
463 my_conf+="${mysqlsock}"
464 elif use mysqli ; then
465 my_conf+="${mysqlsock}"
466 fi
467
468 # ODBC support
469 my_conf+="
470 $(use_with odbc unixODBC ${EPREFIX}/usr)
471 $(use_with iodbc iodbc ${EPREFIX}/usr)"
472
473 # Oracle support
474 if use oci8-instant-client ; then
475 my_conf+="
476 $(use_with oci8-instant-client oci8)"
477 fi
478
479 # PDO support
480 if use pdo ; then
481 my_conf+="
482 $(use_with mssql pdo-dblib )
483 $(use_with mysql pdo-mysql ${mysqllib})
484 $(use_with postgres pdo-pgsql )
485 $(use_with sqlite pdo-sqlite ${EPREFIX}/usr)
486 $(use_with odbc pdo-odbc unixODBC,${EPREFIX}/usr)"
487 if use oci8-instant-client ; then
488 my_conf+="
489 $(use_with oci8-instant-client pdo-oci)"
490 fi
491 fi
492
493 # readline/libedit support
494 my_conf+="
495 $(use_with readline readline ${EPREFIX}/usr)
496 $(use_with libedit libedit ${EPREFIX}/usr)"
497
498 # Session support
499 if use session ; then
500 my_conf+="
501 $(use_with sharedmem mm ${EPREFIX}/usr)"
502 else
503 my_conf+="
504 $(use_enable session session )"
505 fi
506
507 # Use pic for shared modules such as apache2's mod_php
508 my_conf="${my_conf} --with-pic"
509
510 # we use the system copy of pcre
511 # --with-pcre-regex affects ext/pcre
512 # --with-pcre-dir affects ext/filter and ext/zip
513 my_conf="${my_conf} --with-pcre-regex=${EPREFIX}/usr --with-pcre-dir=${EPREFIX}/usr"
514
515 # Catch CFLAGS problems
516 # Fixes bug #14067.
517 # Changed order to run it in reverse for bug #32022 and #12021.
518 replace-cpu-flags "k6*" "i586"
519
520 # Support user-passed configuration parameters
521 my_conf="${my_conf} ${EXTRA_ECONF:-}"
522
523 # Support the Apache2 extras, they must be set globally for all
524 # SAPIs to work correctly, especially for external PHP extensions
525
526 mkdir -p "${WORKDIR}/sapis-build"
527 for one_sapi in $SAPIS ; do
528 use "${one_sapi}" || continue
529 php_set_ini_dir "${one_sapi}"
530
531 cp -r "${S}" "${WORKDIR}/sapis-build/${one_sapi}"
532 cd "${WORKDIR}/sapis-build/${one_sapi}"
533
534 sapi_conf="${my_conf} --with-config-file-path=${PHP_INI_DIR}
535 --with-config-file-scan-dir=${PHP_EXT_INI_DIR_ACTIVE}"
536
537 for sapi in $SAPIS ; do
538 case "$sapi" in
539 cli|cgi|embed|fpm)
540 if [[ "${one_sapi}" == "${sapi}" ]] ; then
541 sapi_conf="${sapi_conf} --enable-${sapi}"
542 else
543 sapi_conf="${sapi_conf} --disable-${sapi}"
544 fi
545 ;;
546
547 apache2)
548 if [[ "${one_sapi}" == "${sapi}" ]] ; then
549 sapi_conf="${sapi_conf} --with-apxs2=${EPREFIX}/usr/sbin/apxs"
550 else
551 sapi_conf="${sapi_conf} --without-apxs2"
552 fi
553 ;;
554 esac
555 done
556
557 econf ${sapi_conf}
558 done
559 }
560
561 src_compile() {
562 # snmp seems to run during src_compile, too (bug #324739)
563 addpredict /usr/share/snmp/mibs/.index
564 addpredict /var/lib/net-snmp/mib_indexes
565
566 for sapi in ${SAPIS} ; do
567 if use "${sapi}"; then
568 cd "${WORKDIR}/sapis-build/$sapi" || "Failed to change dir to ${WORKDIR}/sapis-build/$1"
569 emake || die "emake failed"
570 fi
571 done
572 }
573
574 src_install() {
575 # see bug #324739 for what happens when we don't have that
576 addpredict /usr/share/snmp/mibs/.index
577
578 # grab the first SAPI that got built and install common files from there
579 local first_sapi=""
580 for sapi in $SAPIS ; do
581 if use $sapi ; then
582 first_sapi=$sapi
583 break
584 fi
585 done
586
587 # Makefile forgets to create this before trying to write to it...
588 dodir "${PHP_DESTDIR#${EPREFIX}}/bin"
589
590 # Install php environment (without any sapis)
591 cd "${WORKDIR}/sapis-build/$first_sapi"
592 emake INSTALL_ROOT="${D}" \
593 install-build install-headers install-programs \
594 || die "emake install failed"
595
596 local extension_dir="$("${ED}/${PHP_DESTDIR#${EPREFIX}}/bin/php-config" --extension-dir)"
597
598 # Create the directory where we'll put version-specific php scripts
599 keepdir /usr/share/php${PHP_MV}
600
601 local sapi="", file=""
602 local sapi_list=""
603
604 for sapi in ${SAPIS}; do
605 if use "${sapi}" ; then
606 einfo "Installing SAPI: ${sapi}"
607 cd "${WORKDIR}/sapis-build/${sapi}"
608
609 if [[ "${sapi}" == "apache2" ]] ; then
610 # We're specifically not using emake install-sapi as libtool
611 # may cause unnecessary relink failures (see bug #351266)
612 insinto "${PHP_DESTDIR#${EPREFIX}}/apache2/"
613 newins ".libs/libphp5$(get_libname)" "libphp${PHP_MV}$(get_libname)"
614 keepdir "/usr/$(get_libdir)/apache2/modules"
615 else
616 # needed each time, php_install_ini would reset it
617 local dest="${PHP_DESTDIR#${EPREFIX}}"
618 into "${dest}"
619 case "$sapi" in
620 cli)
621 source="sapi/cli/php"
622 ;;
623 cgi)
624 source="sapi/cgi/php-cgi"
625 ;;
626 fpm)
627 source="sapi/fpm/php-fpm"
628 ;;
629 embed)
630 source="libs/libphp${PHP_MV}$(get_libname)"
631 ;;
632 *)
633 die "unhandled sapi in src_install"
634 ;;
635 esac
636
637 if [[ "${source}" == *"$(get_libname)" ]]; then
638 dolib.so "${source}" || die "Unable to install ${sapi} sapi"
639 else
640 dobin "${source}" || die "Unable to install ${sapi} sapi"
641 local name="$(basename ${source})"
642 dosym "${dest}/bin/${name}" "/usr/bin/${name}${SLOT}"
643 fi
644 fi
645
646 php_install_ini "${sapi}"
647
648 # construct correct SAPI string for php-config
649 # thanks to ferringb for the bash voodoo
650 if [[ "${sapi}" == "apache2" ]]; then
651 sapi_list="${sapi_list:+${sapi_list} }apache2handler"
652 else
653 sapi_list="${sapi_list:+${sapi_list} }${sapi}"
654 fi
655 fi
656 done
657
658 # Installing opcache module
659 if use_if_iuse opcache ; then
660 dolib.so "modules/opcache$(get_libname)" || die "Unable to install opcache module"
661 fi
662
663 # Install env.d files
664 newenvd "${FILESDIR}/20php5-envd" \
665 "20php${SLOT}"
666 sed -e "s|/lib/|/$(get_libdir)/|g" -i \
667 "${ED}/etc/env.d/20php${SLOT}"
668 sed -e "s|php5|php${SLOT}|g" -i \
669 "${ED}/etc/env.d/20php${SLOT}"
670
671 # set php-config variable correctly (bug #278439)
672 sed -e "s:^\(php_sapis=\)\".*\"$:\1\"${sapi_list}\":" -i \
673 "${ED}/usr/$(get_libdir)/php${SLOT}/bin/php-config"
674
675 if use fpm ; then
676 if use systemd; then
677 systemd_newunit "${FILESDIR}/php-fpm_at.service" "php-fpm@${SLOT}.service"
678 else
679 systemd_newunit "${FILESDIR}/php-fpm_at-simple.service" "php-fpm@${SLOT}.service"
680 fi
681 fi
682 }
683
684 src_test() {
685 echo ">>> Test phase [test]: ${CATEGORY}/${PF}"
686 PHP_BIN="${WORKDIR}/sapis-build/cli/sapi/cli/php"
687 if [[ ! -x "${PHP_BIN}" ]] ; then
688 ewarn "Test phase requires USE=cli, skipping"
689 return
690 else
691 export TEST_PHP_EXECUTABLE="${PHP_BIN}"
692 fi
693
694 if [[ -x "${WORKDIR}/sapis/cgi/php-cgi" ]] ; then
695 export TEST_PHP_CGI_EXECUTABLE="${WORKDIR}/sapis/cgi/php-cgi"
696 fi
697
698 REPORT_EXIT_STATUS=1 "${TEST_PHP_EXECUTABLE}" -n -d "session.save_path=${T}" \
699 "${WORKDIR}/sapis-build/cli/run-tests.php" -n -q -d "session.save_path=${T}"
700
701 for name in ${EXPECTED_TEST_FAILURES}; do
702 mv "${name}.out" "${name}.out.orig" 2>/dev/null
703 done
704
705 local failed="$(find -name '*.out')"
706 if [[ ${failed} != "" ]] ; then
707 ewarn "The following test cases failed unexpectedly:"
708 for name in ${failed}; do
709 ewarn " ${name/.out/}"
710 done
711 else
712 einfo "No unexpected test failures, all fine"
713 fi
714
715 if [[ ${PHP_SHOW_UNEXPECTED_TEST_PASS} == "1" ]] ; then
716 local passed=""
717 for name in ${EXPECTED_TEST_FAILURES}; do
718 [[ -f "${name}.diff" ]] && continue
719 passed="${passed} ${name}"
720 done
721 if [[ ${passed} != "" ]] ; then
722 einfo "The following test cases passed unexpectedly:"
723 for name in ${passed}; do
724 ewarn " ${passed}"
725 done
726 else
727 einfo "None of the known-to-fail tests passed, all fine"
728 fi
729 fi
730 }
731
732 pkg_postinst() {
733 # Output some general info to the user
734 if use apache2 ; then
735 APACHE2_MOD_DEFINE="PHP5"
736 APACHE2_MOD_CONF="70_mod_php5" # actually provided by app-eselect/eselect-php
737 apache-module_pkg_postinst
738 fi
739
740 # Create the symlinks for php
741 for m in ${SAPIS}; do
742 [[ ${m} == 'embed' ]] && continue;
743 if use $m ; then
744 local ci=$(eselect php show $m)
745 if [[ -z $ci ]]; then
746 eselect php set $m php${SLOT}
747 einfo "Switched ${m} to use php:${SLOT}"
748 einfo
749 elif [[ $ci != "php${SLOT}" ]] ; then
750 elog "To switch $m to use php:${SLOT}, run"
751 elog " eselect php set $m php${SLOT}"
752 elog
753 fi
754 fi
755 done
756
757 elog "Make sure that PHP_TARGETS in ${EPREFIX}/etc/make.conf includes php${SLOT/./-} in order"
758 elog "to compile extensions for the ${SLOT} ABI"
759 elog
760 if ! use readline && use cli ; then
761 ewarn "Note that in order to use php interactivly, you need to enable"
762 ewarn "the readline USE flag or php -a will hang"
763 fi
764 elog
765 elog "This ebuild installed a version of php.ini based on php.ini-${PHP_INI_VERSION} version."
766 elog "You can chose which version of php.ini to install by default by setting PHP_INI_VERSION to either"
767 elog "'production' or 'development' in ${EPREFIX}/etc/make.conf"
768 elog "Both versions of php.ini can be found in ${EPREFIX}/usr/share/doc/${PF}"
769
770 elog
771 elog "For more details on how minor version slotting works (PHP_TARGETS) please read the upgrade guide:"
772 elog "http://www.gentoo.org/proj/en/php/php-upgrading.xml"
773 elog
774 }
775
776 pkg_prerm() {
777 eselect php cleanup
778 }